/* $Id: x86_compat.h,v 1.12 2001/06/10 22:36:40 mikpe Exp $
 * Performance-monitoring counters driver.
 * x86-specific compatibility definitions for 2.2/2.4 kernels.
 *
 * Copyright (C) 2000-2001  Mikael Pettersson
 */
#include <linux/config.h>
#include <linux/version.h>

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,0)

/* missing from <asm-i386/processor.h> */
#define cpu_has_mmx	(test_bit(X86_FEATURE_MMX,  boot_cpu_data.x86_capability))
#define cpu_has_msr	(test_bit(X86_FEATURE_MSR,  boot_cpu_data.x86_capability))
#define clr_cap_tsc()	(clear_bit(X86_FEATURE_TSC, boot_cpu_data.x86_capability))

#else	/* 2.4 simulation for 2.2 */

#define cpu_has_mmx	(boot_cpu_data.x86_capability & X86_FEATURE_MMX)
#define cpu_has_msr	(boot_cpu_data.x86_capability & X86_FEATURE_MSR)
#define cpu_has_tsc	(boot_cpu_data.x86_capability & X86_FEATURE_TSC)
#define clr_cap_tsc()	(boot_cpu_data.x86_capability &= ~X86_FEATURE_TSC)

#define X86_CR4_TSD	0x0004
#define X86_CR4_PCE	0x0100

unsigned long mmu_cr4_features;	/*fake*/

#define set_in_cr4(mask)	set_in_cr4_local((mask))

#endif	/* 2.4 simulation for 2.2 */

extern unsigned long cpu_khz;
